#ifndef _LINUX_FLAT_H
#define _LINUX_FLAT_H

struct flat_hdr {
	char magic[4];			/* bFLT magic */
	unsigned long version;		/* binfmt_flat version */
	unsigned long entry;		/* Offset of first executable instruction with text segment from beginning of file*/
	unsigned long data_start;	/* Offset of data segment from beginning of file*/
	unsigned long data_end;		/* Offset of end of data segment from beginning of file*/
	unsigned long bss_end;		/* Offset of end of bss segment from beginning of file*/
					/* (It is assumed that data_end through bss_end for bss segment.) */
	unsigned long stack_size;	/* Size of stack, in bytes */
	unsigned long reloc_start;	/* Offset of relocation records from beginning of file */
	unsigned long reloc_count;	/* Number of relocation records */
	unsigned long filler[7];	/* Reservered, set to zero */
};

#define FLAT_RELOC_TYPE_TEXT 0
#define FLAT_RELOC_TYPE_DATA 1
#define FLAT_RELOC_TYPE_BSS 2

struct flat_reloc {
	unsigned long value; /* 2: type, 30: offset */
};

#endif /* _LINUX_FLAT_H */
