
#include "mathf.h"
#include <stdio.h>

#define PSH(X) (*(buf++)=(X))
#define PEEK() buf[-1]
#define POP() *(--buf) = '\0'

#define PLUS 1
#define SPACE 2

#define fabs(x) ((x)<0 ? (-x) : (x))

/* FIXME: This file contains roundoff error */

#ifdef original_hacky_gcvt

char * gcvt(float f, size_t ndigit, char * buf)
{
  int i;
  int z;
  int flags = 0;
  int exp = 0;
  char *c = buf;

  if (f < 0.0f) {
    PSH('-');
    f = -f;
  } else {
    if (flags & PLUS) PSH('+');
    if (flags & SPACE) PSH(' ');
  }
  
  if (f) {
    while (f < 1.0f) {
      f *=10.0f;
      exp--;
    }

    while (f >= 10.0f) {
      f /=10.0f;
      exp++;
    }
  }

  while ((exp > 0) && (exp < 7)) {
	  PSH('0'+f);
	  z = f;
	  f -= z;
	  f *= 10.0f;
  	exp--;
  }

  PSH('0'+f);
  z = f;
  f -= z;
  f *= 10.0f;

  PSH('.');

  for (i=0;i<ndigit;i++) {
    PSH('0'+f);
    z = f;
    f -= z;
    f *= 10;
  }
  
  if (exp != 0) {
	  PSH('e');
	  if (exp < 0) {
	    PSH('-');
	    exp = -exp;
	  } else {
	    PSH('+');
	  }
	  
	  PSH('0'+exp/10%10);
	  PSH('0'+exp%10);

 }

  PSH(0);

  return c;
}

#else

char * gcvt(float f, size_t ndigit, char * buf)
{
  int i;
  int z;
  int exp = 0;
  char *c = buf, * decimal;

  if (f < 0.0f) {
    PSH('-');
    f = -f;
  }
  
  if (!f) {
  	PSH('0');
  	PSH(0);
  	return c;
  }
  
  i = 1;
  while (f >= 10.0f) {
  	f /= 10.0f;
  	i++;
  }
  
  while (i>0) {
  	z = f;
  	PSH('0'+z);
  	f -= z;
  	f *= 10.0f;
  	i--;
  }
  
  decimal = buf;
  
  PSH('.');
  
  for (i=0;i<ndigit;i++) {
    z = f;
    PSH('0'+z);
    f -= z;
    f *= 10.0f;
  }
  
trim:
  switch (PEEK()) {
  case '0':
  	POP();
  	goto trim;
  case '.':
  	POP();
  }
  
  PSH(0);

  return c;
}

#endif
